<?xml version='1.0' encoding="windows-1251"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version='1.0'>

<xsl:output encoding="utf8" method="text"/>

<xsl:param name="dn-base">dc=localdomain</xsl:param>
<xsl:param name="minuid">1001</xsl:param>
<xsl:param name="mingid">1001</xsl:param>
<xsl:param name="sid">S-1</xsl:param>

<xsl:template match="User">
  <xsl:text>dn: cn=</xsl:text>
  <xsl:value-of select="@login"/>
  <xsl:text>,ou=Group,</xsl:text>
  <xsl:value-of select="$dn-base"/>
  <xsl:text>&#10;</xsl:text>
  <xsl:text>objectClass: top&#10;</xsl:text>
  <xsl:text>objectClass: posixGroup&#10;</xsl:text>
  <xsl:text>cn: </xsl:text>
  <xsl:value-of select="@login"/>
  <xsl:text>&#10;</xsl:text>
  <xsl:text>gidNumber: </xsl:text>
  <xsl:value-of select="$mingid+count(preceding::User)"/>
  <xsl:text>&#10;</xsl:text>
  <xsl:text>&#10;</xsl:text>

  <xsl:text>dn: uid=</xsl:text>
  <xsl:value-of select="@login"/>
  <xsl:text>,ou=People,</xsl:text>
  <xsl:value-of select="$dn-base"/>
  <xsl:text>&#10;</xsl:text>
  <xsl:text>uid: </xsl:text>
  <xsl:value-of select="@login"/>
  <xsl:text>&#10;</xsl:text>
  <xsl:text>objectClass: top&#10;</xsl:text>
  <xsl:text>objectClass: person&#10;</xsl:text>
  <xsl:text>objectClass: posixAccount&#10;</xsl:text>
  <xsl:text>objectClass: organizationalPerson&#10;</xsl:text>
  <xsl:text>objectClass: inetOrgPerson&#10;</xsl:text>
  <xsl:text>objectClass: sambaSamAccount&#10;</xsl:text>
  <xsl:text>objectClass: shadowAccount&#10;</xsl:text>
  <xsl:text>uidNumber: </xsl:text>
  <xsl:value-of select="$minuid+count(preceding::User)"/>
  <xsl:text>&#10;</xsl:text>
  <xsl:text>sambaSID: </xsl:text>
  <xsl:value-of select="$sid"/>
  <xsl:text>-</xsl:text>
  <xsl:value-of select="1000+2*($minuid+count(preceding::User))"/>
  <xsl:text>&#10;</xsl:text>
  <xsl:text>gidNumber: </xsl:text>
  <xsl:value-of select="$mingid+count(preceding::User)"/>
  <xsl:text>&#10;</xsl:text>
  <xsl:text>homeDirectory: /home/</xsl:text>
  <xsl:value-of select="@login"/>
  <xsl:text>&#10;</xsl:text>
  <xsl:text>loginShell: /bin/bash&#10;</xsl:text>
  <xsl:text>sambaLMPassword: NO PASSWORDXXXX&#10;</xsl:text>
  <xsl:text>sambaNTPassword: NO PASSWORDXXXX&#10;</xsl:text>
  <xsl:text>sambaPwdLastSet: 2147483647&#10;</xsl:text>
  <xsl:text>sambaLogonTime: 0&#10;</xsl:text>
  <xsl:text>sambaLogoffTime: 2147483647&#10;</xsl:text>
  <xsl:text>sambaKickoffTime: 2147483647&#10;</xsl:text>
  <xsl:text>sambaPwdCanChange: 0&#10;</xsl:text>
  <xsl:text>sambaPwdMustChange: 0&#10;</xsl:text>
  <xsl:text>sambaAcctFlags: [U]&#10;</xsl:text>
  <xsl:if test="normalize-space(role) != ''">
    <xsl:text>title: </xsl:text>
    <xsl:value-of select="role"/>
    <xsl:text>&#10;</xsl:text>
  </xsl:if>
  <xsl:if test="normalize-space(class) != ''">
    <xsl:text>ou: </xsl:text>
    <xsl:value-of select="class"/>
    <xsl:text>&#10;</xsl:text>
  </xsl:if>
  <xsl:text>cn: </xsl:text>
  <xsl:value-of select="@name"/>
  <xsl:text>&#10;</xsl:text>
  <xsl:if test="normalize-space(@firstname) != ''">
    <xsl:text>givenName: </xsl:text>
    <xsl:value-of select="@firstname"/>
    <xsl:text>&#10;</xsl:text>
  </xsl:if>
  <xsl:if test="normalize-space(@secondname) != ''">
    <xsl:text>initials: </xsl:text>
    <xsl:value-of select="@secondname"/>
    <xsl:text>&#10;</xsl:text>
  </xsl:if>
  <xsl:text>surname: </xsl:text>
  <xsl:choose>
    <xsl:when test="normalize-space(@surname) != ''">
      <xsl:value-of select="@surname"/>
    </xsl:when>
    <xsl:otherwise>
      <xsl:value-of select="@name"/>
    </xsl:otherwise>
  </xsl:choose>
  <xsl:text>&#10;</xsl:text>
  <xsl:text>&#10;</xsl:text>

  <xsl:text>### </xsl:text>
  <xsl:value-of select="@login"/>
  <xsl:text> </xsl:text>
  <xsl:value-of select="$minuid+count(preceding::User)"/>
  <xsl:text> </xsl:text>
  <xsl:value-of select="$mingid+count(preceding::User)"/>
  <xsl:text>&#10;</xsl:text>
  <xsl:text>&#10;</xsl:text>
</xsl:template>

<xsl:template match="*|@*|text()">
  <xsl:apply-templates/>
</xsl:template>

</xsl:stylesheet>


