$ENV{'PATH'}= '/bin:/usr/bin';
$ENV{'SHELL'}= '/bin/sh';

delete @ENV{qw(IFS CDPATH ENV BASH_ENV)};

use strict;
use Crypt::SmbHash;

my $arg;
my $update_samba_passwd = 0;
my $update_unix_passwd = 0;

foreach $arg (@ARGV) {
    if ( substr( $arg, 0, 1 ) eq '-' ) {
        if ( $arg eq '-h' || $arg eq '-?' || $arg eq '--help' ) {
            print "Usage: $0 [options]\n";
            print "  -h, -?, --help show this help message\n";
            print "  -r             reset UNIX password\n";
	    print "  -R             reset Samba password\n";
            exit (6);
        } elsif ($arg eq '-r') {
            $update_unix_passwd = 1;
        } elsif ($arg eq '-R') {
            $update_samba_passwd = 1;
        }
    }
}

while ( my $line=<STDIN> ) {
    if ( $update_samba_passwd == 1 ) {
	next if ( $line =~ /^sambaLMPassword:.*/ );
	next if ( $line =~ /^sambaNTPassword:.*/ );
    }
    print "$line";
    if ( $line =~ /^uid: (.*)$/ ) {
	if ( $update_unix_passwd == 1 ) {
	    print "userPassword: $1_password\n"
	}
	if ( $update_samba_passwd == 1 ) {
	    my ($sambaLMPassword,$sambaNTPassword) = ntlmgen "$1_password";
	    print "sambaLMPassword: $sambaLMPassword\n";
	    print "sambaNTPassword: $sambaNTPassword\n"
	}
    }
}
